package me.km.commands;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Location;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

public class CommandTop extends ModuleCommand
{
    public CommandTop(Module m) 
    {
        super("top", m);
        super.setDescription("Teleportiert einen Spieler nach oben");
        super.setUsage("/top [player]");
        super.setPermission(Permissions.TOP);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]); 
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
        }
        World w = affectedPlayer.getEntityWorld();
        Vec3d v = affectedPlayer.getPositionVector();
        v = v.addVector(0, w.getHeight((int) v.x, (int) v.z) - v.y, 0);
        Utils.teleportEntity(affectedPlayer, new Location(w, v));
        this.getModule().send(cs, "Du wurdest nach oben teleportiert.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " wurde nach oben teleportiert.");
        }
        return true;
    }
}
